searchData={"content_type":"text/markdown","items":[{"doc":"GenStage/Broadway producers for Extreme","ref":"Kelvin.html","title":"Kelvin","type":"module"},{"doc":"Determines the stream position of a subscription event from Extreme\n\nThis function can be used by a GenStage consumer to a linear subscription in\norder to persist stream position.","ref":"Kelvin.html#stream_position/1","title":"Kelvin.stream_position/1","type":"function"},{"doc":"A subscription producer which processes events in order as they appear\nin the EventStoreDB","ref":"Kelvin.InOrderSubscription.html","title":"Kelvin.InOrderSubscription","type":"module"},{"doc":"* `:name` - (optional) the GenServer name for this producer\n* `:stream_name` - (required) the stream name to which to subscribe\n* `:connection` - (required) the Extreme client module to use as a\n  connection to the EventStoreDB. This may either be the name of the\n  Extreme client module or its pid.\n* `:restore_stream_position!` - (required) a function which determines\n  the stream position from which this listener should begin after initializing\n  or restarting. Values may be either an MFA tuple or a 0-arity anonymous\n  function.\n* `:subscribe_on_init?` - (required) a function which determines whether\n  the producer should subscribe immediately after starting up. Values may\n  be either an MFA tuple or a 0-arity anonymous function. The function\n  should return either `true` to subscribe immediately on initialization or\n  `false` if the author intends on manually subscribing the producer. This\n  producer can be manually subscribed by `send/2`ing a message of\n  `:subscribe` to the process.\n* `:subscribe_after` - (default: `Enum.random(3_000..5_000)`) the amount of\n  time to wait after initializing to query the `:subscribe_on_init?` option.\n  This can be useful to prevent all producers from trying to subscribe at\n  the same time and to await an active connection to the EventStoreDB.\n* `:catch_up_chunk_size` - (default: `256`) the number of events to query\n  for each read chunk while catching up. This option presents a trade-off\n  between network queries and query duration over the network.","ref":"Kelvin.InOrderSubscription.html#module-options","title":"Options - Kelvin.InOrderSubscription","type":"module"},{"doc":"","ref":"Kelvin.InOrderSubscription.html#start_link/1","title":"Kelvin.InOrderSubscription.start_link/1","type":"function"},{"doc":"# Changelog\n\nAll notable changes to this project will be documented in this file.\n\nThe format is based on [Keep a\nChangelog](https://keepachangelog.com/en/1.0.0/), and this project adheres to\n[Semantic Versioning](https://semver.org/spec/v2.0.0.html).","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"- Use new `Extreme.ListenerWithBackPressure`","ref":"changelog.html#1-1-0-2024-06-18","title":"1.1.0 - 2024-06-18 - Changelog","type":"extras"},{"doc":"- Bump all dependencies including bumping `:extreme` to v1.0.5 which fixes a\n  bug with live events sometimes getting dropped after subscribing to a stream","ref":"changelog.html#1-0-1-2024-01-31","title":"1.0.1 - 2024-01-31 - Changelog","type":"extras"},{"doc":"This release represents stability in the API. There is no functional change\nbetween this release and v0.4.2.","ref":"changelog.html#1-0-0-2022-05-11","title":"1.0.0 - 2022-05-11 - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#0-4-2-2022-01-26","title":"0.4.2 - 2022-01-26 - Changelog","type":"extras"},{"doc":"- Sending an InOrderSubscription process a `:subscribe` message no longer\n  creates a duplicate subscription. Instead a warning is emitted.","ref":"changelog.html#fixed","title":"Fixed - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#0-4-1-2021-08-12","title":"0.4.1 - 2021-08-12 - Changelog","type":"extras"},{"doc":"- Changed the InOrderSubscription internals to buffer events from the\n  extreme subscription in a queue when there is no demand\n    - this unlocks the ability for this producer to emit multiple events\n      at once","ref":"changelog.html#changed","title":"Changed - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#0-4-0-2021-06-10","title":"0.4.0 - 2021-06-10 - Changelog","type":"extras"},{"doc":"- Added `:subscribe_after` option which determines how long the producer will\n  wait before checking whether it should subscribe or not","ref":"changelog.html#added","title":"Added - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#0-3-0-2021-06-04","title":"0.3.0 - 2021-06-04 - Changelog","type":"extras"},{"doc":"- Events are now produced in the shape of `{producer, event}` instead of simply\n  `event`\n    - this allows a consumer to use the name of the producer to inform decisions\n      about how to store the stream position","ref":"changelog.html#changed","title":"Changed - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#0-2-2-2021-06-03","title":"0.2.2 - 2021-06-03 - Changelog","type":"extras"},{"doc":"- Blanket configuration of the `:catch_up_chunk_size` can be set with the\n  `:kelvin` application-env var of `:catch_up_chunk_size`, defaulting to 256","ref":"changelog.html#added","title":"Added - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#0-2-1-2021-06-03","title":"0.2.1 - 2021-06-03 - Changelog","type":"extras"},{"doc":"- Increased timeout in call to subscibe in InOrder subscriber\n\n#","ref":"changelog.html#fixed","title":"Fixed - Changelog","type":"extras"},{"doc":"- Added a configuration parameter for the InOrder subscription which controls\n  the batch size of events read while catching up: `:catch_up_chunk_size`","ref":"changelog.html#added","title":"Added - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#0-2-0-2021-06-01","title":"0.2.0 - 2021-06-01 - Changelog","type":"extras"},{"doc":"- Added noise to start-up-time checking of the auto-subscription option\n    - This works well for awaiting the bring-up of a client to an external\n      service such as LaunchDarkly","ref":"changelog.html#added","title":"Added - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#0-1-0-2021-06-01","title":"0.1.0 - 2021-06-01 - Changelog","type":"extras"},{"doc":"- Initial implementation of the in-order subscription GenStage producer","ref":"changelog.html#added","title":"Added - Changelog","type":"extras"},{"doc":"#","ref":"changelog.html#0-0-0-2021-05-27","title":"0.0.0 - 2021-05-27 - Changelog","type":"extras"},{"doc":"- This project was generated by Gaas","ref":"changelog.html#added","title":"Added - Changelog","type":"extras"}]}